"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("reshow-runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("reshow-runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("reshow-runtime/helpers/createSuper"));

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("reshow-runtime/helpers/typeof"));

var _reshowFlux = require("reshow-flux");

var _immutable = require("immutable");

var _getObjectValue = _interopRequireDefault(require("get-object-value"));

var _callFunc = _interopRequireDefault(require("call-func"));

var _dispatcher = _interopRequireWildcard(require("../dispatcher"));

var alertCount = 0;
var isArray = Array.isArray;
var keys = Object.keys;

var toMessage = function toMessage(message) {
  if (-1 !== 'string|number'.indexOf((0, _typeof2["default"])(message))) {
    message = {
      message: message
    };
  }

  if (!message.id) {
    message.id = 'm-' + alertCount;
    alertCount++;
  }

  return message;
};

var getMessage = function getMessage(action) {
  return toMessage((0, _getObjectValue["default"])(action, ['params', 'message']));
};

var MessageStore = /*#__PURE__*/function (_ReduceStore) {
  (0, _inherits2["default"])(MessageStore, _ReduceStore);

  var _super = (0, _createSuper2["default"])(MessageStore);

  function MessageStore() {
    var _this;

    (0, _classCallCheck2["default"])(this, MessageStore);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "dialogCallback", null);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "alertMap", {});
    return _this;
  }

  (0, _createClass2["default"])(MessageStore, [{
    key: "getAlertList",
    value: function getAlertList() {
      var _this2 = this;

      return keys(this.alertMap).map(function (key) {
        return _this2.alertMap[key];
      });
    }
  }, {
    key: "dialogStart",
    value: function dialogStart(state, action) {
      var params = (0, _getObjectValue["default"])(action, ['params']);
      var dialog = params.dialog,
          dialogProps = params.dialogProps,
          dialogTo = params.dialogTo,
          callback = params.callback;
      var next = {
        dialog: dialog
      };

      if (dialogProps) {
        next.dialogProps = dialogProps;
      }

      if (dialogTo) {
        next.dialogTo = dialogTo;
      }

      if (callback) {
        this.dialogCallback = callback;
      }

      return state.merge(next);
    }
  }, {
    key: "dialogEnd",
    value: function dialogEnd(state, action) {
      var dialogTo = state.get('dialogTo');

      if (!dialogTo) {
        dialogTo = 'dialogReturn';
      }

      var value = (0, _getObjectValue["default"])(action, ['params', 'item', 'props', 'value']);
      (0, _dispatcher.dispatch)((0, _defineProperty2["default"])({}, dialogTo, value));
      (0, _callFunc["default"])(this.dialogCallback, [value]);
      this.dialogCallback = null;
      return state["delete"]('dialog')["delete"]('dialogProps')["delete"]('dialogTo');
    }
  }, {
    key: "alertReset",
    value: function alertReset(state, action) {
      var _this3 = this;

      var alerts = (0, _getObjectValue["default"])(action, ['params', 'alerts']);
      this.alertMap = {};

      if (isArray(alerts)) {
        alerts.map(function (a) {
          var message = toMessage(a);
          _this3.alertMap[message.id] = message;
        });
      }

      return state.set('alerts', this.getAlertList());
    }
  }, {
    key: "alertDel",
    value: function alertDel(state, action) {
      var id = (0, _getObjectValue["default"])(action, ['params', 'id']);
      delete this.alertMap[id];
      return state.set('alerts', this.getAlertList());
    }
  }, {
    key: "alertAdd",
    value: function alertAdd(state, action) {
      var alerts = state.get('alerts');
      var message = getMessage(action);
      var alertProps = (0, _getObjectValue["default"])(action, ['params', 'alertProps']);

      if (alertProps) {
        state = state.set('alertProps', alertProps);
      }

      this.alertMap[message.id] = message;
      return state.set('alerts', this.getAlertList());
    }
  }, {
    key: "reduce",
    value: function reduce(state, action) {
      switch (action.type) {
        case 'dialog/start':
          return this.dialogStart(state, action);

        case 'dialog/end':
          return this.dialogEnd(state, action);

        case 'alert/reset':
          return this.alertReset(state, action);

        case 'alert/del':
          return this.alertDel(state, action);

        case 'alert/add':
          return this.alertAdd(state, action);

        default:
          return state;
      }
    }
  }]);
  return MessageStore;
}(_reshowFlux.ReduceStore); // Export a singleton instance of the store


var _default = new MessageStore(_dispatcher["default"]);

exports["default"] = _default;
module.exports = exports.default;