"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.update = exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));

var _assertThisInitialized2 = _interopRequireDefault(require("reshow-runtime/helpers/assertThisInitialized"));

var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("reshow-runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("reshow-runtime/helpers/createSuper"));

var _react = _interopRequireWildcard(require("react"));

var _getObjectValue = _interopRequireDefault(require("get-object-value"));

var _organismReactAjax = require("organism-react-ajax");

var _winDoc = require("win-doc");

var _callFunc = _interopRequireDefault(require("call-func"));

var _reshowReturn = require("reshow-return");

var _ReshowComponent = require("../molecules/ReshowComponent");

var _updateCanonicalUrl = _interopRequireWildcard(require("../../src/updateCanonicalUrl"));

var _dispatcher = require("../../src/dispatcher");

var _globalStore = require("../../src/stores/globalStore");

var _pageStore = _interopRequireDefault(require("../../src/stores/pageStore"));

var isArray = Array.isArray;
var isInit;

var update = function update(params) {
  var realTimeData = (0, _getObjectValue["default"])(params, ["--realTimeData--"]);
  var reset = (0, _getObjectValue["default"])(params, ["--reset--"]);
  var type = realTimeData ? "realTime" : "config/" + (reset ? "re" : "") + "set";
  (0, _dispatcher.dispatch)(type, (0, _reshowReturn.toJS)(params));
  var oDoc = (0, _winDoc.doc)();

  if (oDoc.URL) {
    var htmlTitle = (0, _getObjectValue["default"])(params, ["htmlTitle"]);

    if (htmlTitle) {
      if (isArray(htmlTitle)) {
        oDoc.title = (0, _getObjectValue["default"])(htmlTitle, [0]);
      } else {
        oDoc.title = htmlTitle;
      }
    }

    var canonical = (0, _getObjectValue["default"])(params, ["data", "canonical"]);

    if (canonical) {
      (0, _updateCanonicalUrl["default"])(canonical, params);
    }
  }
};

exports.update = update;

var Reshow = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(Reshow, _PureComponent);

  var _super = (0, _createSuper2["default"])(Reshow);

  (0, _createClass2["default"])(Reshow, [{
    key: "getPath",
    value: function getPath() {
      return this.resetGlobalPath();
    }
  }, {
    key: "resetGlobalPath",
    value: function resetGlobalPath(path) {
      if (path) {
        setTimeout(function () {
          return (0, _dispatcher.dispatch)({
            themePath: path
          });
        });
      } else {
        path = _pageStore["default"].getThemePath();
      }

      _globalStore.globalStore.path = path;
      return _globalStore.globalStore.path;
    }
  }, {
    key: "getGlobalPath",
    value: function getGlobalPath() {
      return _globalStore.globalStore.path;
    }
  }], [{
    key: "getDerivedStateFromError",
    value: function getDerivedStateFromError(error) {
      return {
        hasError: true
      };
    }
  }]);

  function Reshow(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, Reshow);
    _this = _super.call(this, props);

    if (isInit) {
      console.warn("The best practice is avoid multi Reshow Component.");
      _this.state = {
        hasError: true
      };
    } else {
      update(props);
      _this.state = {
        hasError: false
      };
      isInit = 1;
    }

    _this.getPath = _this.getPath.bind((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }

  (0, _createClass2["default"])(Reshow, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // Server site version also need update Canonical
      (0, _updateCanonicalUrl.initCanonicalUrl)(this.props);
    }
  }, {
    key: "componentDidCatch",
    value: function componentDidCatch(error, info) {
      var onError = this.props.onError;

      if (onError) {
        (0, _callFunc["default"])(onError, [error, info]);
      } else {
        console.error([error, info]);
      }

      this.setState({
        hasError: true
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var hasError = this.state.hasError;

      if (hasError) {
        return null;
      }

      var _this$props = this.props,
          onError = _this$props.onError,
          themes = _this$props.themes,
          ajax = _this$props.ajax,
          webSocketUrl = _this$props.webSocketUrl;
      return /*#__PURE__*/_react["default"].createElement(_ReshowComponent.Return, {
        initStates: ["baseUrl", "staticVersion", "themePath"]
      }, function () {
        return /*#__PURE__*/_react["default"].createElement(_organismReactAjax.AjaxPage, {
          callback: update
          /*State*/
          ,
          themePath: _this2.getPath()
          /*Props*/
          ,
          themes: themes,
          ajax: ajax,
          webSocketUrl: webSocketUrl
        });
      });
    }
  }]);
  return Reshow;
}(_react.PureComponent);

var _default = Reshow;
exports["default"] = _default;