"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutProperties"));

var _objectSpread2 = _interopRequireDefault(require("reshow-runtime/helpers/objectSpread2"));

var _react = _interopRequireWildcard(require("react"));

var _getObjectValue = _interopRequireDefault(require("get-object-value"));

var _reshowFlux = require("reshow-flux");

var _reactAtomicMolecule = require("react-atomic-molecule");

var _ReshowComponent = require("../molecules/ReshowComponent");

var _realTimeStore = _interopRequireDefault(require("../../src/stores/realTimeStore"));

var REAL_TIME_KEY = '--realTimeData--';
var REAL_TIME_URL = '--realTimeUrl--';
var keys = Object.keys;

var getStores = function getStores(props) {
  return props.stores || [_realTimeStore["default"]];
};

var calculateState = function calculateState(prevState, props) {
  var realTimeState = _realTimeStore["default"].getState();

  var path = props.realTimePath,
      url = props.realTimeUrl,
      realTimeReset = props.realTimeReset;
  var data = (0, _getObjectValue["default"])(realTimeState, path);
  var wsUrl = (0, _getObjectValue["default"])(realTimeState, [REAL_TIME_URL]);

  if (data && (!url || url === wsUrl)) {
    data[REAL_TIME_URL] = wsUrl;
    return data;
  } else {
    if (realTimeReset) {
      // Reset for when reconnection to new websocket server
      // will not send duplicate data to client
      var reset = {};
      keys(prevState).forEach(function (key) {
        return reset[key] = null;
      });
      return reset;
    }
  }
};

var defaultProps = (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, _ReshowComponent.returnOptions.defaultProps), {}, {
  realTimePath: [REAL_TIME_KEY],
  realTimeUrl: null,
  realTimeReset: false
});
var myReturnOptions = (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, _ReshowComponent.returnOptions), {}, {
  getStores: getStores,
  calculateState: calculateState,
  defaultProps: defaultProps
});

var RealTimeReturn = function RealTimeReturn(props) {
  var children = props.children,
      realTimePath = props.realTimePath,
      otherProps = (0, _objectWithoutProperties2["default"])(props, ["children", "realTimePath"]);

  var myOtherProps = _ReshowComponent.returnOptions.reset(otherProps);

  return /*#__PURE__*/_react["default"].createElement(_ReshowComponent.Return, null, function (pageState) {
    return (0, _reactAtomicMolecule.build)(children)((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, pageState), myOtherProps));
  });
};

var _default = (0, _reshowFlux.connectHook)(RealTimeReturn, myReturnOptions);

exports["default"] = _default;
module.exports = exports.default;