"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectSpread2 = _interopRequireDefault(require("reshow-runtime/helpers/objectSpread2"));

var _objectWithoutProperties2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _getObjectValue = _interopRequireDefault(require("get-object-value"));

var _reactAtomicMolecule = require("react-atomic-molecule");

var _reshowFlux = require("reshow-flux");

var _ReshowComponent = require("../molecules/ReshowComponent");

var _returnOptions$defaul = _ReshowComponent.returnOptions.defaultProps,
    pathStates = _returnOptions$defaul.pathStates,
    otherDefaultProps = (0, _objectWithoutProperties2["default"])(_returnOptions$defaul, ["pathStates"]);
var myReturnOptions = (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, _ReshowComponent.returnOptions), {}, {
  defaultProps: (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, otherDefaultProps), {}, {
    initStates: ['section', 'I18N']
  })
});

var Section = function Section(props) {
  var section = props.section,
      immutable = props.immutable,
      children = props.children,
      otherProps = (0, _objectWithoutProperties2["default"])(props, ["section", "immutable", "children"]);

  if (!section) {
    return null;
  }

  var name = props.name;
  var allParams = myReturnOptions.reset(otherProps);

  if (immutable) {
    var thisSection = section.get(name);

    if (!thisSection) {
      return null;
    }

    var shouldRender = thisSection.get('shouldRender');

    if (!shouldRender) {
      return null;
    }

    thisSection["delete"]('shouldRender').keySeq().forEach(function (key) {
      allParams[key] = thisSection.get(key);
    });
  } else {
    var _get = (0, _getObjectValue["default"])(section, [name], {}),
        _shouldRender = _get.shouldRender,
        others = (0, _objectWithoutProperties2["default"])(_get, ["shouldRender"]);

    if (!_shouldRender) {
      return null;
    }

    allParams = (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, others), allParams);
  }

  var noName = children.every ? children.every(function (child) {
    return !(0, _getObjectValue["default"])(child, ['props', 'name']);
  }) : !(0, _getObjectValue["default"])(children, ['props', 'name']);

  if (!noName) {
    delete allParams['name'];
  }

  return (0, _reactAtomicMolecule.build)(children)(allParams);
};

Section.displayName = 'Section';

var _default = (0, _reshowFlux.connectHook)(Section, myReturnOptions);

exports["default"] = _default;
module.exports = exports.default;