"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("reshow-runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("reshow-runtime/helpers/createSuper"));

var _react = _interopRequireWildcard(require("react"));

var _index = require("../../../src/index");

var _chai = require("chai");

var _enzyme = require("enzyme");

var _enzymeAdapterReact = _interopRequireDefault(require("enzyme-adapter-react-16"));

(0, _enzyme.configure)({
  adapter: new _enzymeAdapterReact["default"]()
});

var _ref = /*#__PURE__*/_react["default"].createElement("div", null);

describe('Test Section', function () {
  var TestEl = /*#__PURE__*/function (_PureComponent) {
    (0, _inherits2["default"])(TestEl, _PureComponent);

    var _super = (0, _createSuper2["default"])(TestEl);

    function TestEl() {
      (0, _classCallCheck2["default"])(this, TestEl);
      return _super.apply(this, arguments);
    }

    (0, _createClass2["default"])(TestEl, [{
      key: "render",
      value: function render() {
        return _ref;
      }
    }]);
    return TestEl;
  }(_react.PureComponent);

  var FakeComponent = /*#__PURE__*/function (_PureComponent2) {
    (0, _inherits2["default"])(FakeComponent, _PureComponent2);

    var _super2 = (0, _createSuper2["default"])(FakeComponent);

    function FakeComponent() {
      (0, _classCallCheck2["default"])(this, FakeComponent);
      return _super2.apply(this, arguments);
    }

    (0, _createClass2["default"])(FakeComponent, [{
      key: "render",
      value: function render() {
        var _this = this;

        var _this$props = this.props,
            immutable = _this$props.immutable,
            name = _this$props.name;
        return /*#__PURE__*/_react["default"].createElement(_index.Section, {
          name: name,
          immutable: immutable
        }, /*#__PURE__*/_react["default"].createElement(TestEl, {
          ref: function ref(el) {
            return _this.el = el;
          }
        }));
      }
    }]);
    return FakeComponent;
  }(_react.PureComponent);

  (0, _defineProperty2["default"])(FakeComponent, "defaultProps", {
    name: 'test'
  });
  beforeEach(function () {
    return (0, _index.dispatch)('config/reset');
  });

  var _ref2 = /*#__PURE__*/_react["default"].createElement(FakeComponent, null);

  it('Section is existed', function (done) {
    var vDom = _ref2;
    var uFake = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      },
      I18N: {
        ddd: 'fff'
      }
    });
    setTimeout(function () {
      (0, _chai.expect)(uFake.el.props.aaa).to.deep.equal({
        bbb: 'ccc'
      });
      (0, _chai.expect)(uFake.el.props.I18N).to.deep.equal({
        ddd: 'fff'
      });
      done();
    });
  });

  var _ref3 = /*#__PURE__*/_react["default"].createElement(FakeComponent, {
    name: "xxx"
  });

  it('Section is not existed', function (done) {
    var vDom = _ref3;
    var uFake = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: null
    });
    setTimeout(function () {
      (0, _chai.expect)('undefined' === typeof uFake.el).to.be["true"];
      done();
    });
  });

  var _ref4 = /*#__PURE__*/_react["default"].createElement(FakeComponent, {
    immutable: true
  });

  it('Section is existed with immutable', function (done) {
    var vDom = _ref4;
    var uFake = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      },
      I18N: {
        ddd: 'fff'
      }
    });
    setTimeout(function () {
      (0, _chai.expect)(uFake.el.props.aaa.toJS()).to.deep.equal({
        bbb: 'ccc'
      });
      (0, _chai.expect)(uFake.el.props.I18N.toJS()).to.deep.equal({
        ddd: 'fff'
      });
      done();
    });
  });

  var _ref5 = /*#__PURE__*/_react["default"].createElement(FakeComponent, {
    name: "xxx",
    immutable: true
  });

  it('Section is not existed with immutable', function (done) {
    var vDom = _ref5;
    var uFake = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: null
    });
    setTimeout(function () {
      (0, _chai.expect)('undefined' === typeof uFake.el).to.be["true"];
      done();
    });
  });
  it('pass name to child', function (done) {
    var PassName = /*#__PURE__*/function (_PureComponent3) {
      (0, _inherits2["default"])(PassName, _PureComponent3);

      var _super3 = (0, _createSuper2["default"])(PassName);

      function PassName() {
        (0, _classCallCheck2["default"])(this, PassName);
        return _super3.apply(this, arguments);
      }

      (0, _createClass2["default"])(PassName, [{
        key: "render",
        value: function render() {
          var _this2 = this;

          var _this$props2 = this.props,
              immutable = _this$props2.immutable,
              name = _this$props2.name;
          return /*#__PURE__*/_react["default"].createElement(_index.Section, {
            name: "test"
          }, /*#__PURE__*/_react["default"].createElement("div", {
            ref: function ref(el) {
              return _this2.el = el;
            }
          }));
        }
      }]);
      return PassName;
    }(_react.PureComponent);

    var vDom = /*#__PURE__*/_react["default"].createElement(PassName, null);

    var wrap = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      }
    });
    setTimeout(function () {
      (0, _chai.expect)(wrap.el.getAttribute('name')).to.equal('test');
      done();
    });
  });
  it('not pass name if child already have name', function (done) {
    var NotPassName = /*#__PURE__*/function (_PureComponent4) {
      (0, _inherits2["default"])(NotPassName, _PureComponent4);

      var _super4 = (0, _createSuper2["default"])(NotPassName);

      function NotPassName() {
        (0, _classCallCheck2["default"])(this, NotPassName);
        return _super4.apply(this, arguments);
      }

      (0, _createClass2["default"])(NotPassName, [{
        key: "render",
        value: function render() {
          var _this3 = this;

          var _this$props3 = this.props,
              immutable = _this$props3.immutable,
              name = _this$props3.name;
          return /*#__PURE__*/_react["default"].createElement(_index.Section, {
            name: "test"
          }, /*#__PURE__*/_react["default"].createElement("div", {
            name: "test2",
            ref: function ref(el) {
              return _this3.el = el;
            }
          }));
        }
      }]);
      return NotPassName;
    }(_react.PureComponent);

    var vDom = /*#__PURE__*/_react["default"].createElement(NotPassName, null);

    var wrap = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      }
    });
    setTimeout(function () {
      (0, _chai.expect)(wrap.el.getAttribute('name')).to.equal('test2');
      done();
    });
  });
  it('not pass name if one of child already have name', function (done) {
    var NotPassNameMultiChild = /*#__PURE__*/function (_PureComponent5) {
      (0, _inherits2["default"])(NotPassNameMultiChild, _PureComponent5);

      var _super5 = (0, _createSuper2["default"])(NotPassNameMultiChild);

      function NotPassNameMultiChild() {
        (0, _classCallCheck2["default"])(this, NotPassNameMultiChild);
        return _super5.apply(this, arguments);
      }

      (0, _createClass2["default"])(NotPassNameMultiChild, [{
        key: "render",
        value: function render() {
          var _this4 = this;

          var _this$props4 = this.props,
              immutable = _this$props4.immutable,
              name = _this$props4.name;
          return /*#__PURE__*/_react["default"].createElement(_index.Section, {
            name: "test"
          }, /*#__PURE__*/_react["default"].createElement("div", {
            ref: function ref(el) {
              return _this4.el1 = el;
            }
          }), /*#__PURE__*/_react["default"].createElement("div", {
            name: "test2",
            ref: function ref(el) {
              return _this4.el2 = el;
            }
          }));
        }
      }]);
      return NotPassNameMultiChild;
    }(_react.PureComponent);

    var vDom = /*#__PURE__*/_react["default"].createElement(NotPassNameMultiChild, null);

    var wrap = (0, _enzyme.mount)(vDom);
    var uObj = wrap.instance();
    (0, _index.dispatch)({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      }
    });
    setTimeout(function () {
      (0, _chai.expect)(uObj.el1.getAttribute('name')).to.be["null"];
      (0, _chai.expect)(uObj.el2.getAttribute('name')).to.equal('test2');
      done();
    });
  });
});