"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("reshow-runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("reshow-runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("reshow-runtime/helpers/createSuper"));

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _index = require("../../../src/index");

var _chai = require("chai");

var _enzyme = require("enzyme");

var _enzymeAdapterReact = _interopRequireDefault(require("enzyme-adapter-react-16"));

(0, _enzyme.configure)({
  adapter: new _enzymeAdapterReact["default"]()
});

var _ref = /*#__PURE__*/_react["default"].createElement("div", null);

describe('Test Storage Return', function () {
  var TestEl = /*#__PURE__*/function (_PureComponent) {
    (0, _inherits2["default"])(TestEl, _PureComponent);

    var _super = (0, _createSuper2["default"])(TestEl);

    function TestEl() {
      var _this;

      (0, _classCallCheck2["default"])(this, TestEl);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _super.call.apply(_super, [this].concat(args));
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "show", 0);
      return _this;
    }

    (0, _createClass2["default"])(TestEl, [{
      key: "render",
      value: function render() {
        this.show++;
        return _ref;
      }
    }]);
    return TestEl;
  }(_react.PureComponent);

  var FakeComponent = /*#__PURE__*/function (_PureComponent2) {
    (0, _inherits2["default"])(FakeComponent, _PureComponent2);

    var _super2 = (0, _createSuper2["default"])(FakeComponent);

    function FakeComponent() {
      (0, _classCallCheck2["default"])(this, FakeComponent);
      return _super2.apply(this, arguments);
    }

    (0, _createClass2["default"])(FakeComponent, [{
      key: "render",
      value: function render() {
        var _this2 = this;

        var storage = this.props.storage;
        return /*#__PURE__*/_react["default"].createElement(_index.Return, {
          stores: [storage]
        }, /*#__PURE__*/_react["default"].createElement(TestEl, {
          ref: function ref(el) {
            return _this2.el = el;
          }
        }));
      }
    }]);
    return FakeComponent;
  }(_react.PureComponent);

  var _ref2 = /*#__PURE__*/_react["default"].createElement(FakeComponent, {
    storage: _index.localStorageStore
  });

  it('test get local storage', function () {
    var vDom = _ref2;
    var uFake = (0, _enzyme.mount)(vDom).instance();
    var uString = 'test123';
    (0, _index.storageDispatch)('local', {
      data: uString
    });
    setTimeout(function () {
      (0, _chai.expect)(uFake.el.props.data).to.equal(uString);
    });
  });

  var _ref3 = /*#__PURE__*/_react["default"].createElement(FakeComponent, {
    storage: _index.sessionStorageStore
  });

  it('test get session storage', function (done) {
    var vDom = _ref3;
    var uFake = (0, _enzyme.mount)(vDom).instance();
    var uString = 'test456';
    (0, _index.storageDispatch)('session', {
      data: uString
    });
    setTimeout(function () {
      (0, _chai.expect)(uFake.el.props.data).to.equal(uString);
      done();
    });
  });
});