import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _createSuper from "reshow-runtime/es/helpers/createSuper";
import { ReduceStore } from 'reshow-flux';
import get from 'get-object-value';
import { localStorage, Storage } from 'get-storage';
import storageDispatcher from '../storageDispatcher';

var LocalStorageStore = /*#__PURE__*/function (_ReduceStore) {
  _inherits(LocalStorageStore, _ReduceStore);

  var _super = _createSuper(LocalStorageStore);

  function LocalStorageStore() {
    _classCallCheck(this, LocalStorageStore);

    return _super.apply(this, arguments);
  }

  _createClass(LocalStorageStore, [{
    key: "getInitialState",
    value: function getInitialState() {
      return new Storage(localStorage);
    }
  }, {
    key: "updateStorage",
    value: function updateStorage(state, action) {
      var params = get(action, ['params']);
      return state.merge(params);
    }
  }, {
    key: "reduce",
    value: function reduce(state, action) {
      switch (action.type) {
        case 'local':
          return this.updateStorage(state, action);

        default:
          return state;
      }
    }
  }]);

  return LocalStorageStore;
}(ReduceStore);

export default new LocalStorageStore(storageDispatcher);
export { LocalStorageStore };