import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _assertThisInitialized from "reshow-runtime/es/helpers/assertThisInitialized";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _createSuper from "reshow-runtime/es/helpers/createSuper";
import React, { PureComponent } from "react";
import get from "get-object-value";
import { AjaxPage } from "organism-react-ajax";
import { doc } from "win-doc";
import callfunc from "call-func";
import { toJS } from "reshow-return";
import { Return } from "../molecules/ReshowComponent";
import updateCanonicalUrl, { initCanonicalUrl } from "../../src/updateCanonicalUrl";
import { dispatch } from "../../src/dispatcher";
import { globalStore } from "../../src/stores/globalStore";
import pageStore from "../../src/stores/pageStore";
var isArray = Array.isArray;
var isInit;

var update = function update(params) {
  var realTimeData = get(params, ["--realTimeData--"]);
  var reset = get(params, ["--reset--"]);
  var type = realTimeData ? "realTime" : "config/" + (reset ? "re" : "") + "set";
  dispatch(type, toJS(params));
  var oDoc = doc();

  if (oDoc.URL) {
    var htmlTitle = get(params, ["htmlTitle"]);

    if (htmlTitle) {
      if (isArray(htmlTitle)) {
        oDoc.title = get(htmlTitle, [0]);
      } else {
        oDoc.title = htmlTitle;
      }
    }

    var canonical = get(params, ["data", "canonical"]);

    if (canonical) {
      updateCanonicalUrl(canonical, params);
    }
  }
};

var Reshow = /*#__PURE__*/function (_PureComponent) {
  _inherits(Reshow, _PureComponent);

  var _super = _createSuper(Reshow);

  _createClass(Reshow, [{
    key: "getPath",
    value: function getPath() {
      return this.resetGlobalPath();
    }
  }, {
    key: "resetGlobalPath",
    value: function resetGlobalPath(path) {
      if (path) {
        setTimeout(function () {
          return dispatch({
            themePath: path
          });
        });
      } else {
        path = pageStore.getThemePath();
      }

      globalStore.path = path;
      return globalStore.path;
    }
  }, {
    key: "getGlobalPath",
    value: function getGlobalPath() {
      return globalStore.path;
    }
  }], [{
    key: "getDerivedStateFromError",
    value: function getDerivedStateFromError(error) {
      return {
        hasError: true
      };
    }
  }]);

  function Reshow(props) {
    var _this;

    _classCallCheck(this, Reshow);

    _this = _super.call(this, props);

    if (isInit) {
      console.warn("The best practice is avoid multi Reshow Component.");
      _this.state = {
        hasError: true
      };
    } else {
      update(props);
      _this.state = {
        hasError: false
      };
      isInit = 1;
    }

    _this.getPath = _this.getPath.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Reshow, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // Server site version also need update Canonical
      initCanonicalUrl(this.props);
    }
  }, {
    key: "componentDidCatch",
    value: function componentDidCatch(error, info) {
      var onError = this.props.onError;

      if (onError) {
        callfunc(onError, [error, info]);
      } else {
        console.error([error, info]);
      }

      this.setState({
        hasError: true
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var hasError = this.state.hasError;

      if (hasError) {
        return null;
      }

      var _this$props = this.props,
          onError = _this$props.onError,
          themes = _this$props.themes,
          ajax = _this$props.ajax,
          webSocketUrl = _this$props.webSocketUrl;
      return /*#__PURE__*/React.createElement(Return, {
        initStates: ["baseUrl", "staticVersion", "themePath"]
      }, function () {
        return /*#__PURE__*/React.createElement(AjaxPage, {
          callback: update
          /*State*/
          ,
          themePath: _this2.getPath()
          /*Props*/
          ,
          themes: themes,
          ajax: ajax,
          webSocketUrl: webSocketUrl
        });
      });
    }
  }]);

  return Reshow;
}(PureComponent);

export default Reshow;
export { update };