import _objectSpread from "reshow-runtime/es/helpers/objectSpread2";
import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _assertThisInitialized from "reshow-runtime/es/helpers/assertThisInitialized";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _createSuper from "reshow-runtime/es/helpers/createSuper";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";
import React, { PureComponent, memo } from "react";
import { AlertsNotifier, Dialog, DisplayPopupEl } from "organism-react-popup";
import { build, SemanticUI } from "react-atomic-molecule";
import { toJS } from "reshow-return";
import { Return } from "../molecules/ReshowComponent"; // src

import messageStore from "../../src/stores/messageStore";
import { dispatch } from "../../src/index";

var Body = /*#__PURE__*/function (_PureComponent) {
  _inherits(Body, _PureComponent);

  var _super = _createSuper(Body);

  function Body() {
    var _this;

    _classCallCheck(this, Body);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "handleDismiss", function (e) {
      var _e$data;

      var id = e === null || e === void 0 ? void 0 : (_e$data = e.data) === null || _e$data === void 0 ? void 0 : _e$data.id;

      if (id) {
        dispatch("alert/del", {
          id: id
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleClick", function (e, item) {
      setTimeout(function () {
        var dialog = _this.props.dialog;

        if (dialog) {
          dispatch("dialog/end", {
            item: item
          });
        }
      });
    });

    return _this;
  }

  _createClass(Body, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          defaultAlertProps = _this$props.defaultAlertProps,
          defaultDialogProps = _this$props.defaultDialogProps,
          alerts = _this$props.alerts,
          alertProps = _this$props.alertProps,
          alertComponent = _this$props.alertComponent,
          dialog = _this$props.dialog,
          dialogProps = _this$props.dialogProps,
          dialogComponent = _this$props.dialogComponent;
      var thisDialog = null;

      if (dialog) {
        thisDialog = /*#__PURE__*/React.createElement(DisplayPopupEl, null, build(dialogComponent)(_objectSpread(_objectSpread(_objectSpread({}, defaultDialogProps), toJS(dialogProps)), {}, {
          onClick: this.handleClick,
          onClose: this.handleClick
        }), toJS(dialog)));
      }

      return /*#__PURE__*/React.createElement(SemanticUI, null, thisDialog, build(alertComponent)(_objectSpread(_objectSpread(_objectSpread({}, defaultAlertProps), toJS(alertProps)), {}, {
        onDismiss: this.handleDismiss,
        alerts: toJS(alerts)
      })));
    }
  }]);

  return Body;
}(PureComponent);

_defineProperty(Body, "defaultProps", {
  dialogComponent: Dialog,
  alertComponent: AlertsNotifier
});

var ReshowMessage = /*#__PURE__*/memo(function (props) {
  return /*#__PURE__*/React.createElement(Return, {
    stores: [messageStore],
    initStates: ["alerts", "alertProps", "dialog", "dialogProps"]
  }, /*#__PURE__*/React.createElement(Body, props));
});
ReshowMessage.displayName = "ReshowMessage";
export default ReshowMessage;