import _objectSpread from "reshow-runtime/es/helpers/objectSpread2";
import _objectWithoutProperties from "reshow-runtime/es/helpers/objectWithoutProperties";
import React from 'react';
import get from 'get-object-value';
import { build } from 'react-atomic-molecule';
import { connectHook } from 'reshow-flux';
import { returnOptions } from '../molecules/ReshowComponent';

var _returnOptions$defaul = returnOptions.defaultProps,
    pathStates = _returnOptions$defaul.pathStates,
    otherDefaultProps = _objectWithoutProperties(_returnOptions$defaul, ["pathStates"]);

var myReturnOptions = _objectSpread(_objectSpread({}, returnOptions), {}, {
  defaultProps: _objectSpread(_objectSpread({}, otherDefaultProps), {}, {
    initStates: ['section', 'I18N']
  })
});

var Section = function Section(props) {
  var section = props.section,
      immutable = props.immutable,
      children = props.children,
      otherProps = _objectWithoutProperties(props, ["section", "immutable", "children"]);

  if (!section) {
    return null;
  }

  var name = props.name;
  var allParams = myReturnOptions.reset(otherProps);

  if (immutable) {
    var thisSection = section.get(name);

    if (!thisSection) {
      return null;
    }

    var shouldRender = thisSection.get('shouldRender');

    if (!shouldRender) {
      return null;
    }

    thisSection["delete"]('shouldRender').keySeq().forEach(function (key) {
      allParams[key] = thisSection.get(key);
    });
  } else {
    var _get = get(section, [name], {}),
        _shouldRender = _get.shouldRender,
        others = _objectWithoutProperties(_get, ["shouldRender"]);

    if (!_shouldRender) {
      return null;
    }

    allParams = _objectSpread(_objectSpread({}, others), allParams);
  }

  var noName = children.every ? children.every(function (child) {
    return !get(child, ['props', 'name']);
  }) : !get(children, ['props', 'name']);

  if (!noName) {
    delete allParams['name'];
  }

  return build(children)(allParams);
};

Section.displayName = 'Section';
export default connectHook(Section, myReturnOptions);