import _defineProperty from "reshow-runtime/es/helpers/defineProperty";
import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _createSuper from "reshow-runtime/es/helpers/createSuper";
import React, { PureComponent } from 'react';
import { Section, dispatch } from '../../../src/index';
import { expect } from 'chai';
import { shallow, mount, configure } from 'enzyme';
import Adapter from 'enzyme-adapter-react-16';
configure({
  adapter: new Adapter()
});

var _ref = /*#__PURE__*/React.createElement("div", null);

describe('Test Section', function () {
  var TestEl = /*#__PURE__*/function (_PureComponent) {
    _inherits(TestEl, _PureComponent);

    var _super = _createSuper(TestEl);

    function TestEl() {
      _classCallCheck(this, TestEl);

      return _super.apply(this, arguments);
    }

    _createClass(TestEl, [{
      key: "render",
      value: function render() {
        return _ref;
      }
    }]);

    return TestEl;
  }(PureComponent);

  var FakeComponent = /*#__PURE__*/function (_PureComponent2) {
    _inherits(FakeComponent, _PureComponent2);

    var _super2 = _createSuper(FakeComponent);

    function FakeComponent() {
      _classCallCheck(this, FakeComponent);

      return _super2.apply(this, arguments);
    }

    _createClass(FakeComponent, [{
      key: "render",
      value: function render() {
        var _this = this;

        var _this$props = this.props,
            immutable = _this$props.immutable,
            name = _this$props.name;
        return /*#__PURE__*/React.createElement(Section, {
          name: name,
          immutable: immutable
        }, /*#__PURE__*/React.createElement(TestEl, {
          ref: function ref(el) {
            return _this.el = el;
          }
        }));
      }
    }]);

    return FakeComponent;
  }(PureComponent);

  _defineProperty(FakeComponent, "defaultProps", {
    name: 'test'
  });

  beforeEach(function () {
    return dispatch('config/reset');
  });

  var _ref2 = /*#__PURE__*/React.createElement(FakeComponent, null);

  it('Section is existed', function (done) {
    var vDom = _ref2;
    var uFake = mount(vDom).instance();
    dispatch({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      },
      I18N: {
        ddd: 'fff'
      }
    });
    setTimeout(function () {
      expect(uFake.el.props.aaa).to.deep.equal({
        bbb: 'ccc'
      });
      expect(uFake.el.props.I18N).to.deep.equal({
        ddd: 'fff'
      });
      done();
    });
  });

  var _ref3 = /*#__PURE__*/React.createElement(FakeComponent, {
    name: "xxx"
  });

  it('Section is not existed', function (done) {
    var vDom = _ref3;
    var uFake = mount(vDom).instance();
    dispatch({
      section: null
    });
    setTimeout(function () {
      expect('undefined' === typeof uFake.el).to.be["true"];
      done();
    });
  });

  var _ref4 = /*#__PURE__*/React.createElement(FakeComponent, {
    immutable: true
  });

  it('Section is existed with immutable', function (done) {
    var vDom = _ref4;
    var uFake = mount(vDom).instance();
    dispatch({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      },
      I18N: {
        ddd: 'fff'
      }
    });
    setTimeout(function () {
      expect(uFake.el.props.aaa.toJS()).to.deep.equal({
        bbb: 'ccc'
      });
      expect(uFake.el.props.I18N.toJS()).to.deep.equal({
        ddd: 'fff'
      });
      done();
    });
  });

  var _ref5 = /*#__PURE__*/React.createElement(FakeComponent, {
    name: "xxx",
    immutable: true
  });

  it('Section is not existed with immutable', function (done) {
    var vDom = _ref5;
    var uFake = mount(vDom).instance();
    dispatch({
      section: null
    });
    setTimeout(function () {
      expect('undefined' === typeof uFake.el).to.be["true"];
      done();
    });
  });
  it('pass name to child', function (done) {
    var PassName = /*#__PURE__*/function (_PureComponent3) {
      _inherits(PassName, _PureComponent3);

      var _super3 = _createSuper(PassName);

      function PassName() {
        _classCallCheck(this, PassName);

        return _super3.apply(this, arguments);
      }

      _createClass(PassName, [{
        key: "render",
        value: function render() {
          var _this2 = this;

          var _this$props2 = this.props,
              immutable = _this$props2.immutable,
              name = _this$props2.name;
          return /*#__PURE__*/React.createElement(Section, {
            name: "test"
          }, /*#__PURE__*/React.createElement("div", {
            ref: function ref(el) {
              return _this2.el = el;
            }
          }));
        }
      }]);

      return PassName;
    }(PureComponent);

    var vDom = /*#__PURE__*/React.createElement(PassName, null);
    var wrap = mount(vDom).instance();
    dispatch({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      }
    });
    setTimeout(function () {
      expect(wrap.el.getAttribute('name')).to.equal('test');
      done();
    });
  });
  it('not pass name if child already have name', function (done) {
    var NotPassName = /*#__PURE__*/function (_PureComponent4) {
      _inherits(NotPassName, _PureComponent4);

      var _super4 = _createSuper(NotPassName);

      function NotPassName() {
        _classCallCheck(this, NotPassName);

        return _super4.apply(this, arguments);
      }

      _createClass(NotPassName, [{
        key: "render",
        value: function render() {
          var _this3 = this;

          var _this$props3 = this.props,
              immutable = _this$props3.immutable,
              name = _this$props3.name;
          return /*#__PURE__*/React.createElement(Section, {
            name: "test"
          }, /*#__PURE__*/React.createElement("div", {
            name: "test2",
            ref: function ref(el) {
              return _this3.el = el;
            }
          }));
        }
      }]);

      return NotPassName;
    }(PureComponent);

    var vDom = /*#__PURE__*/React.createElement(NotPassName, null);
    var wrap = mount(vDom).instance();
    dispatch({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      }
    });
    setTimeout(function () {
      expect(wrap.el.getAttribute('name')).to.equal('test2');
      done();
    });
  });
  it('not pass name if one of child already have name', function (done) {
    var NotPassNameMultiChild = /*#__PURE__*/function (_PureComponent5) {
      _inherits(NotPassNameMultiChild, _PureComponent5);

      var _super5 = _createSuper(NotPassNameMultiChild);

      function NotPassNameMultiChild() {
        _classCallCheck(this, NotPassNameMultiChild);

        return _super5.apply(this, arguments);
      }

      _createClass(NotPassNameMultiChild, [{
        key: "render",
        value: function render() {
          var _this4 = this;

          var _this$props4 = this.props,
              immutable = _this$props4.immutable,
              name = _this$props4.name;
          return /*#__PURE__*/React.createElement(Section, {
            name: "test"
          }, /*#__PURE__*/React.createElement("div", {
            ref: function ref(el) {
              return _this4.el1 = el;
            }
          }), /*#__PURE__*/React.createElement("div", {
            name: "test2",
            ref: function ref(el) {
              return _this4.el2 = el;
            }
          }));
        }
      }]);

      return NotPassNameMultiChild;
    }(PureComponent);

    var vDom = /*#__PURE__*/React.createElement(NotPassNameMultiChild, null);
    var wrap = mount(vDom);
    var uObj = wrap.instance();
    dispatch({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      }
    });
    setTimeout(function () {
      expect(uObj.el1.getAttribute('name')).to.be["null"];
      expect(uObj.el2.getAttribute('name')).to.equal('test2');
      done();
    });
  });
});